// Star Wars Titles

// by Yoruk for Instructables


//Create the famous titles with customed text !      

// 12 12 15 : first version of the code
                                       
                                       
//send commments or questions to Yoruk16_72 AT yahoo DOT fr
                                      

#version 3.7;

#include "colors.inc"
                       
       
       
//custom parameters :        
       
#declare ActivateStarfield = false;    
      
#declare TextColor = Yellow ;     
  
#declare TextScale = 1.1;                    
            
#declare ActivateLightSpot = false;                            
 
 
      
      
      
      
      
global_settings {      
        assumed_gamma 1.08 
}
                       

       
        
        
#if (ActivateStarfield)        

        #include "textures.inc"  //ready made libraries
      
        #include "stars.inc" 
        
 
        sphere{ <0,0,0>, 1
                texture{ Starfield scale .1}
                scale 2000
        } 
   
                     
        sphere{ <0,0,0>, 1
                texture{ pigment {color rgbt <0,0,0,0.3>}}
                scale 1800
        } 
         
#end      
     
            
   
   
   
   
      /*
   // create a point "spotlight" (conical directed) light source
light_source {
  <0,0,0>                 // light's position (translated below)
  color rgb <1,1,1>       // light's color
  spotlight               // this kind of light source
  translate <40, 80, -40> // <x y z> position of light
  point_at <0, 0, 0>      // direction of spotlight
  radius 5                // hotspot (inner, in degrees)
  tightness 50            // tightness of falloff (1...100) lower is softer, higher is tighter
  falloff 8               // intensity falloff radius (outer, in degrees)
}
    */  
         
#declare Ligne = 0;
         
#fopen MyFile "TEXT.TXT" read  
          
          
        //tout le texte 
        
#declare BlocTexte =union {            
           
        
        #while (defined(MyFile)) //read the file until the end    
                                                   
              
                #read (MyFile,MyString) //read one line...            
                    
                #debug MyString                       
                #debug "\n"  
                
                #if (defined(MyFile))
                        //and display it                                        
                        text { ttf "arial.ttf", MyString, 0.001, 0.0 translate <0,Ligne,0> } 
                 
                #end
                 
                #declare  Ligne = Ligne-1;  //next line...                  
                   
        #end      
            
        translate <-5.5,clock*Ligne*-1.3*TextScale,0>     //center the text and translate it following the animation variable
                                  
                                  
        scale TextScale //here we apply the scale    

       
        pigment {color TextColor} //and we apply the custom color           
                        
                        
}
         

#fclose MyFile   //close the file
                       
union {BlocTexte }
                         
                         
#declare Xcamera = (max_extent ( BlocTexte ).x  +  min_extent ( BlocTexte ).x ) /2;
        
        
camera {
        location <Xcamera,0,10>
        look_at <Xcamera,0,0>   
        right -x*image_width/image_height     
        
        rotate <70,0,0>     //we rotate the camera around X axis. try to modify it !!   
}      
     
     

#if (ActivateLightSpot) 
    
        light_source {<Xcamera,100,100>  color rgb <1,1,1>      
                spotlight                
                point_at <Xcamera, -5, 0>   
                radius 5          
                tightness 70      
                falloff 7  //check the help to understand these parameters  
        }        
  
#else
        light_source {<Xcamera,100,100>  color rgb <1,1,1>  }      //simple light
          
     
  
#end